/*
 * Copyright (c) 2018 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.factory.map.primitive;

import org.eclipse.collections.api.block.function.primitive.ByteFunction;
import org.eclipse.collections.api.map.primitive.MutableByteByteMap;
import org.eclipse.collections.api.map.primitive.ByteByteMap;

/**
 * A factory which creates instances of type {@link MutableByteByteMap}.
 * This file was automatically generated from template file mutablePrimitivePrimitiveMapFactory.stg.
 *
 * @since 6.0.
 */
public interface MutableByteByteMapFactory
{
    MutableByteByteMap empty();

    /**
     * Same as {@link #empty()}.
     */
    MutableByteByteMap of();

    /**
     * Same as {@link #empty()}.
     */
    MutableByteByteMap with();

    /**
     * Same as {@link #withAll(ByteByteMap)}.
     */
    MutableByteByteMap ofAll(ByteByteMap map);

    MutableByteByteMap withAll(ByteByteMap map);

    /**
     * Creates an {@code MutableByteByteMap} from an {@code Iterable<T>} by applying {@code keyFunction} and {@code valueFunction}.
     *
     * @since 10.0
     */
    <T> MutableByteByteMap from(Iterable<T> iterable, ByteFunction<? super T> keyFunction, ByteFunction<? super T> valueFunction);
}
